----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 04/05/2016 04:12:33 PM
-- Design Name: 
-- Module Name: pwm_servo - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity pwm_servo is
    Port ( clk : in STD_LOGIC;
           pwm_clk : out STD_LOGIC;
           sw: in std_logic);
end pwm_servo;

architecture Behavioral of pwm_servo is

type ROM is array(0 to 4) of integer;
constant my_nums : ROM := (
	0	=>		80000, --0 
	1	=>		145000, --45
	2	=>		165000, --90
	3	=>		175000, --135 DC
	4	=>		200000 --180 DC
);	
signal pwm_temp : std_logic := '0';	
signal pwm_temp_cnt:  integer := 0;
signal duty_temp: integer := 0;
signal flag2: std_logic := '0';
signal en: std_logic_vector(3 downto 0) := (others => '0');
signal button: integer:= 0;
begin

process (clk)
begin
    IF(RISING_EDGE(clk))THEN
         if pwm_temp_cnt = 2000000 then    
               pwm_temp <= '1';
               pwm_temp_cnt <= 0;
               flag2 <= '1';
         else
               pwm_temp_cnt <= pwm_temp_cnt + 1;
         end if;
     
     
     
      if flag2 = '1' then
        if duty_temp = my_nums(button) then    
                       pwm_temp <= '0';
                       duty_temp <= 0;
                       flag2 <= '0';
         else
               duty_temp <= duty_temp +1;

         end if;    
    end if;
    end if;
end process;

--servo movement according to the switch
process (sw,clk)
begin
     IF(RISING_EDGE(clk))THEN
        case sw is
        when '1' => button <= 2;
        when '0' => button <= 1;
        when others => button <= button; 
        end case;
     end if;
end process;
pwm_clk <= pwm_temp;


end Behavioral;
